package net.rumati.logging.muffero;

import java.util.LinkedList;
import java.util.List;
import net.rumati.logging.muffero.appender.Appender;
import net.rumati.logging.muffero.filter.AppenderOutputFilterChain;
import net.rumati.logging.muffero.filter.Filter;
import net.rumati.logging.muffero.filter.FilterChain;
import net.rumati.logging.muffero.filter.SimpleFilterChain;

public class Log
{
    private final FilterChain filterChain;

    public Log(Appender appender)
    {
        this(appender, new LinkedList<Filter>());
    }

    public Log(Appender appender, List<Filter> filters)
    {
        if (filters.isEmpty()){
            filterChain = new AppenderOutputFilterChain(appender);
        }else{
            filterChain = new SimpleFilterChain(appender, filters);
        }
    }

    FilterChain getFilterChain()
    {
        return filterChain;
    }
}
