package net.rumati.logging.muffero.appender;

import java.io.IOException;
import java.io.Writer;
import net.rumati.logging.muffero.layout.Layout;
import net.rumati.logging.muffero.LogEvent;

public abstract class WriterAppender
    implements Appender
{
    protected abstract Writer getWriter()
        throws IOException;

    protected abstract Layout getLayout();

    public void append(LogEvent event)
    {
        String output = getLayout().format(event);
        Writer w = null;
        try {
            w = getWriter();
            synchronized (w){
                try {
                    w.write(output);
                    w.flush();
                }catch (IOException e){
                    System.err.println("ERROR: " + getClass().getName() + ": Error while writing to log");
                    e.printStackTrace(System.err);
                }
            }
        }catch (IOException e){
            System.err.println("ERROR: " + getClass().getName() + ": Unable to get writer for logging");
            e.printStackTrace(System.err);
        }
    }
}
