package net.rumati.logging.muffero.filter;

import net.rumati.logging.muffero.LogEvent;
import net.rumati.logging.muffero.NDC;
import net.rumati.logging.muffero.Priority;

public class NDCFilter
        implements Filter
{
    private String key;

    public NDCFilter(String key)
    {
        this.key = key;
    }

    public boolean isPriorityEnabled(Priority priority, FilterChain chain)
    {
        if (NDC.contains(key)){
            return chain.isPriorityEnabled(priority);
        }
        
        return false;
    }

    public void doFilter(LogEvent event, FilterChain chain)
    {
        if (NDC.contains(key)){
            chain.doFilter(event);
        }
    }
}
