package net.rumati.logging.muffero.filter;

import net.rumati.logging.muffero.LogEvent;
import net.rumati.logging.muffero.Priority;

public class PriorityFilter
        implements Filter
{
    private final Priority priority;

    public PriorityFilter(Priority priority)
    {
        this.priority = priority;
    }

    public boolean isPriorityEnabled(Priority priority, FilterChain chain)
    {
        if (priority.isLessCriticalThan(this.priority)){
            return false;
        }

        return chain.isPriorityEnabled(priority);
    }

    public void doFilter(LogEvent event, FilterChain chain)
    {
        if (event.getPriority().isLessCriticalThan(priority)){
            return;
        }

        chain.doFilter(event);
    }
}
